'''\
Install script for product PloneAzax
'''

from Products.CMFCore.utils import getToolByName
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.PloneAzax.config import PROJECTNAME, GLOBALS
from cStringIO import StringIO
from zLOG import LOG, DEBUG

def _old_res(tool, id):
    return tool.getResourcesDict().get(id, None)
 
def install_dependencies(self, out):
    pass

## These will be removed as we have a substitute
js_unregister = []
# XXX TODO put them back on reinstall?

js_all = [
## XXX We need at least this sarissa version. 
## This is included here to make sure.
## TODO when it's 100% up to date in Plone, remove this!

# XXX About compression. Some resources are already compressed
# so we don't compress them to gain speed. Preparation is very slow.

    ('++resource++sarissa.js', 'safe'),
    ('++resource++cssQuery.js', 'none'),
    ('++resource++MochiKit.js', 'none'),
    ('++resource++prototype.js', 'none'),
    ('++resource++effects.js', 'none'),
    ('++resource++kukit.js', 'none'),
]

css_all = ['PloneAzax.css']

# kukit kss
kss_all = [
    'PloneAzax.kss', # this goes to normal skin, it should move to resources?
]

def install_resources(self, out):
    jstool = getToolByName(self, 'portal_javascripts')
    for id in js_unregister:
        if _old_res(jstool, id):
            jstool.unregisterResource(id)
            print >> out, "Unregistered old %s" % (id, )
    for id, compression in js_all:
        jstool.registerScript(
            id = id,
            enabled = True,
            cookable = True,
            compression = compression,
            )
    csstool = getToolByName(self, 'portal_css')
    for css in css_all:
        csstool.manage_addStylesheet(
            id = css,
            rel = 'stylesheet',
            rendering = 'link',
            enabled = True,
            cookable = True,
            )
    # kukit-stylesheet
    for kss in kss_all:
        csstool.manage_addStylesheet(id=kss,
            rel='k-stylesheet',
            rendering = 'link',
            enabled=True,
            cookable=False,
            )
    print >> out, "Registered resources"
    
def install_mimetype(self, out):
    mt = getToolByName(self, 'mimetypes_registry')
    mt.manage_addMimeType('KSS (Azax) StyleSheet', ('text/kss', ), ('kss', ), 'text.png',
                           binary=0, globs=('*.kss', ))
    print >> out, "Registered kss mimetype"
   
def install(self):
    out = StringIO()

    install_dependencies(self, out)
    install_mimetype(self, out)

    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)
    print >> out, "Installed types"

    install_subskin(self, out, GLOBALS)
    print >> out, "Installed subskin"

    install_resources(self, out)
    
    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()

# --
# Uninstall
# --

def uninstall_portlets(self, out):
    new_slots = []
    for slot in self.right_slots:
        if not slot in slots:
            new_slots.append(slot)
    self.right_slots = tuple(new_slots)
    out.write('Portlets uninstalled.\n')

def uninstall(self):
    out=StringIO()
    
    uninstall_portlets(self, out)
    
    out.write('Manual uninstall completed.\n')
    return out.getvalue()
