from Products.azax.BeautifulSoup import BeautifulSoup
from Products.azax.plugins.core.interfaces import IKSSCoreCommands

from Products.azax.azaxview import AzaxViewAdapter

class RefreshPortletCommand(AzaxViewAdapter):
    __allow_access_to_unprotected_subobjects__ = 1
    
    def refreshPortlet(self, name, node_id=None):
        'Refresh portlet by name.'
        if name.startswith('portlet-'):
            name = name[8:]
        if node_id is None:
            node_id = name
        portlet_id = "portlet-%s" % (node_id, )
        # render it
        portlet_body = self.view.macroContent('portlet_%s/macros/portlet' % (name, ))
        # Good. Now, unfortunately we don't have any marker on the outside div.
        # So we just select the <dl> for insertion.
        # This could be spared with smarter templating.
        soup = BeautifulSoup(portlet_body)
        tag = soup.find('dl', id=portlet_id)
        result = unicode(tag)
        # Command the replacement
        ksscore = IKSSCoreCommands(self)
        ksscore.replaceHTML(ksscore.getHtmlIdSelector(portlet_id), result)

