# -*- coding: UTF-8 -*-

from zope.interface import implements

from Products.azax.plugins.core.interfaces import IKSSCoreCommands

from azaxview import AzaxBaseView
from deprecated import DeprecatedMethod
from interfaces import IPloneAzaxView

class MacroView(AzaxBaseView):

    # --
    # Macro replacement actions
    # --

    implements(IPloneAzaxView)
    
    def replaceInnerByMacro(self, selector, macropath):
        content = self.macroContent(macropath)
        IKSSCoreCommands(self).replaceInnerHTML(selector, content)
        return self.render()

    def replaceByMacro(self, selector, macropath):
        content = self.macroContent(macropath)
        IKSSCoreCommands(self).replaceHTML(selector, content)
        return self.render()

    # XXX deprecation does not work ???
    #replaceMacro = deprecated(replaceInnerByMacro, 'use replaceInnerByMacro instead')
    def replaceMacro(self, selector, macropath):
        import warnings, textwrap
        warnings.warn(textwrap.dedent('''\
            The usage of the server action replaceMacro is deprecated''' 
        ), DeprecationWarning, 2)
        return self.replaceInnerByMacro(selector, macropath)
