
from plugin import Plugin
from registry import AzaxPluginError

class Action(Plugin):
    '''The action plugin

    '''

    plugintype = 'action'

    def __init__(self, name, jsfile, command_factory, 
            params_mandatory, params_optional, deprecated):
        Plugin.__init__(self, name, jsfile)
        self.command_factory = command_factory
        self.params_mandatory = params_mandatory
        self.params_optional = params_optional
        self.deprecated = deprecated

    def checkRegisteredCommand(cls, name):
        command = cls.getRegistered(name)
        # check if the action has a valid command factory
        if command.command_factory == 'none':
            raise AzaxPluginError, '"%s" is not a registered kss command (or missing command_factory?)' % (name, )
        # issue deprecation warning, if necessary
        command.check_deprecation()
    checkRegisteredCommand = classmethod(checkRegisteredCommand)

    def check_deprecation(self):
        if self.deprecated:
            import warnings, textwrap
            warnings.warn(textwrap.dedent('''\
            The usage of the kss command "%s" is deprecated,
            %s''' % (self.name, self.deprecated)), DeprecationWarning, 2)
