
import os.path
from command import Command
from event_type import EventType
from action import Action
from selector_type import SelectorType
from plugin import registerPlugin

#class AzaxConfigurationError(Exception):
#    pass

# XXX This will go away.
def registerCommand(_context, name, jsfile=None):
    'Directive that registers a command' 
    
    import warnings, textwrap
    warnings.warn(textwrap.dedent('''\
        
          %s

        The directive azax:registerCommand is deprecated and will be removed,
        use azax:registerAction with command_factory="selector" or "global".'''
        % _context.info),
        DeprecationWarning)

    # check to see if the file exists
    if jsfile is not None:
        file(jsfile, 'rb').close()

    _context.action(
        discriminator = ('registerAzaxCommand', name, jsfile),
        callable = registerPlugin,
        args = (Command, name, jsfile),
        )

def registerEventType(_context, name, jsfile=None):
    'Directive that registers an event type' 
    
    # check to see if the file exists
    if jsfile is not None:
        file(jsfile, 'rb').close()

    _context.action(
        discriminator = ('registerAzaxEventType', name, jsfile),
        callable = registerPlugin,
        args = (EventType, name, jsfile),
        )
 
def registerAction(_context, name, jsfile=None, command_factory='none',
        params_mandatory=[], params_optional=[], deprecated=None):
    'Directive that registers an action.' 
    
    # check to see if the file exists
    if jsfile is not None:
        file(jsfile, 'rb').close()

    _context.action(
        discriminator = ('registerAzaxAction', name, jsfile),
        callable = registerPlugin,
        args = (Action, name, jsfile, command_factory, params_mandatory, params_optional, deprecated),
        )

def registerSelectorType(_context, name, jsfile=None):
    'Directive that registers a selector type' 
    
    # check to see if the file exists
    if jsfile is not None:
        file(jsfile, 'rb').close()

    _context.action(
        discriminator = ('registerAzaxSelectorType', name, jsfile),
        callable = registerPlugin,
        args = (SelectorType, name, jsfile),
        )
