from zope.interface import Interface
from zope.schema import TextLine, Choice
from zope.configuration.fields import Path, Tokens, PythonIdentifier

# XXX this will go away
class IRegisterCommandDirective(Interface):
    'Register an AZAX command plugin'
    
    name = TextLine(
         title=u"Name",
         description=u"The name of the command plugin.",
         required=True,
         )
    
    jsfile = Path(
         title=u"Javascript file",
         description=u"The path of the javascript file that defines the plugin",
         required=False,
         )
    
class IRegisterEventTypeDirective(Interface):
    'Register an AZAX event type'
    
    name = TextLine(
         title=u"Name",
         description=u"The name of the event type plugin.",
         required=True,
         )
    
    jsfile = Path(
         title=u"Javascript file",
         description=u"The path of the javascript file that defines the plugin",
         required=False,
         )
    
class IRegisterActionDirective(Interface):
    'Register an AZAX action'
    
    name = TextLine(
         title=u"Name",
         description=u"The name of the action plugin.",
         required=True,
         )
    
    jsfile = Path(
         title=u"Javascript file",
         description=u"The path of the javascript file that defines the plugin",
         required=False,
         )

    command_factory = Choice(
        title=u"Command factory type",
        description=u"Command factory type, by default 'none'.",
        values=(u'none', u'global', u'selector'),
        required=False,
        )

    params_mandatory = Tokens(
        title=u"Mandatory parameters",
        description=u"Space separated list of mandatory parameter names",
        value_type=PythonIdentifier(),
        required=False,
        )

    params_optional = Tokens(
        title=u"Optional parameters",
        description=u"Comma separated list of optional parameter names",
        value_type=PythonIdentifier(),
        required=False,
        )

    deprecated = TextLine(
         title=u"Deprecated",
         description=u"The hint that we should give as warning about deprecation",
         required=False,
         )
 
class IRegisterSelectorTypeDirective(Interface):
    'Register an AZAX selector type'
    
    name = TextLine(
         title=u"Name",
         description=u"The name of the selector type plugin.",
         required=True,
         )
    
    jsfile = Path(
         title=u"Javascript file",
         description=u"The path of the javascript file that defines the plugin",
         required=False,
         )
