
from registry import getRegistry

def registerPlugin(cls, *arg, **kw):
    'Convenience method to help registration'
    plugin = cls(*arg, **kw)
    plugin.register()
    
class Plugin(object):
    'The base plugin class'

    plugintype = None  # need to overwrite this with the plugin type

    def __init__(self, name, jsfile):
        self.name = name
        self.jsfile = jsfile
    
    def register(self):
        '''The registration method
        '''
        getRegistry().register(self)
        
    def isRegistered(cls, name):
        'Tells if name is a registered plugin for the pluginclass'
        return getRegistry().isRegistered(cls.plugintype, name)
    isRegistered = classmethod(isRegistered)

    def getRegistered(cls, name):
        'Gets the regustered plugin and raise error if not registered'
        return getRegistry().getRegistered(cls.plugintype, name)
    getRegistered = classmethod(getRegistered)   

    def checkRegistered(cls, name):
        'Check if name is a registered plugin and raise error otherwise'
        cls.getRegistered(name)
    checkRegistered = classmethod(checkRegistered)
