# -*- coding: ISO-8859-15 -*-
# Copyright (c) 2005
# Authors:
#   Godefroid Chapelle <gotcha@bubblenet.be>
#   Tarek Ziad <tz@nuxeo.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
import unittest, os
from zope.testing import doctest
from Testing.ZopeTestCase import ZopeTestCase
from Products.azax.tests.base import AzaxViewTestCase, FakeContent, \
                                     TestRequest, DebugTestRequest
from Products.azaxdemo.azaxview import AzaxView
from Products.Five.zcml import load_string, load_config
import Products.azaxdemo

class AzaxDemoTestCase(AzaxViewTestCase):
    
    def afterSetUp(self):
        AzaxViewTestCase.afterSetUp(self)
        load_config('permissions.zcml', package=Products.Five)
        load_config('configure.zcml', package=Products.azaxdemo)
        # fake content
        # XXX This is a holy mess. Go go macro adapters!
        fakecontent = FakeContent()
        self.folder._delObject('ob')
        self.folder._setObject('ob', fakecontent)
        fakecontent = fakecontent.__of__(self.folder)
        # Set up a fake view (with no content)
        # XXX commands will be rendered as data structures,
        # because we use DebugTestRequest instead of TestRequest.
        fakedebugrequest = DebugTestRequest()
        self.view = AzaxView(fakecontent, fakedebugrequest)

    def test_instantiation(self):
        view = self.view
        commands = view.getCommands()
        self.assertNotEquals(view, None)

    # XXX This shows the idea of how the commands output can be
    # tested by using DebugTestRequest. 
    def test_getDivContent(self):
        view = self.view
        commands = view.getCommands()
        res = view.getDivContent()
        self.assertEquals(res, [
            {'selectorType': '', 'params': {
                    'html': u'<h1>it worked</h1>'
                }, 'name': 'replaceInnerHTML', 'selector': 'div#demo'}, 
            {'selectorType': '', 'params': {
                    'html': u'<h1>it worked&#160;again</h1>'
                }, 'name': 'replaceInnerHTML', 'selector': 'div#demo'},
            ])

def test_suite():
    return unittest.TestSuite((
        unittest.makeSuite(AzaxDemoTestCase),
        doctest.DocTestSuite('Products.azaxdemo.azaxview'),
        ))
