'''\
Install script for product livesearch
'''

from Products.CMFCore.utils import getToolByName
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.livesearch.config import PROJECTNAME, GLOBALS
from cStringIO import StringIO
from zLOG import LOG, DEBUG

def install_dependencies(self, out):
    qi = getToolByName(self, 'portal_quickinstaller', None)
    qi.installProducts(('PloneAzax', ))
    print >> out, "Installed depending products"

# To get rid of the old method...

def _exists_old_res(tool, id):
    return tool.getResourcesDict().get(id, None) is not None

def remove_old_livesearch(self, out):
    jstool = getToolByName(self, 'portal_javascripts')
    if _exists_old_res(jstool, 'livesearch.js'):
        jstool.unregisterResource('livesearch.js')
        print >> out, "Unregistered old livesearch.js"

def install_old_livesearch(self, out):
    jstool = getToolByName(self, 'portal_javascripts')
    if not _exists_old_res(jstool, 'livesearch.js'):
        jstool.registerScript(
            id = 'livesearch.js',
            enabled = True,
            cookable = True,
            compression = 'safe',
            )
        print >> out, "Re-registered old livesearch.js"

css_all = []

# kukit kss
kss_all = [
    'livesearch.kss',
    ]

def install_resources(self, out):
    csstool = getToolByName(self, 'portal_css')
    for css in css_all:
        csstool.manage_addStylesheet(
            id = css,
            rel = 'stylesheet',
            rendering = 'link',
            enabled = True,
            cookable = True,
            )
    # kukit-stylesheet
    for kss in kss_all:
        csstool.manage_addStylesheet(id=kss,
            rel='kukit',
            rendering = 'link',
            enabled=True,
            cookable=False,
            )
    print >> out, "Registered resources"
 

#portal_properties -> site_properties -> uncheck enable_livesearch

def install(self):
    out = StringIO()

    install_dependencies(self, out)
    remove_old_livesearch(self, out)

    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)
    print >> out, "Installed types"

    install_subskin(self, out, GLOBALS)
    print >> out, "Installed subskin"

    install_resources(self, out)

    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()

# --
# Uninstall
# --

def uninstall_portlets(self, out):
    new_slots = []
    for slot in self.right_slots:
        if not slot in slots:
            new_slots.append(slot)
    self.right_slots = tuple(new_slots)
    out.write('Portlets uninstalled.\n')

def uninstall(self):
    out=StringIO()
    
    uninstall_portlets(self, out)
    install_old_livesearch(self, out)
    
    out.write('Manual uninstall completed.\n')
    return out.getvalue()
