from Testing import ZopeTestCase
import time

'''\
"naked" test installation

this allows running the portal installation in a test case
instead of the afterSetup, thus making it debuggable.

If there is an exception during the installation,
you want to run *this test only* and debug it.
'''

from Products.Archetypes.tests.ArchetypesTestCase import *

# xxx_testcase imports this module to utilize the
# product installation below. This way we do not have
# to manage these from two different places.

PRODUCT = 'livesearch'

ZopeTestCase.installProduct('Five')
ZopeTestCase.installProduct(PRODUCT)

class TestInstall(ArcheSiteTestCase):

    def test_install_product(self):
        'product install'
        self.setRoles(['Manager'])
        # install blogads3 via quickinstaller
        self.portal.portal_quickinstaller.installProduct(PRODUCT)
        
    def test_reinstall_product(self):
        'product reinstall'
        self.setRoles(['Manager'])
        # install blogads3 via quickinstaller
        self.portal.portal_quickinstaller.installProduct(PRODUCT)
        self.portal.portal_quickinstaller.reinstallProducts([PRODUCT])
        
def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestInstall))
    return suite
