/*

// 
// Copyright (c) 2006 Plone Foundation
// Copyright (c) 2006 Balazs Ree <ree@greenfinity.hu>
//
// Original license conditions apply.
//


// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Bitflux GmbH                                      |
// +----------------------------------------------------------------------+
// | Licensed under the Apache License, Version 2.0 (the "License");      |
// | you may not use this file except in compliance with the License.     |
// | You may obtain a copy of the License at                              |
// | http://www.apache.org/licenses/LICENSE-2.0                           |
// | Unless required by applicable law or agreed to in writing, software  |
// | distributed under the License is distributed on an "AS IS" BASIS,    |
// | WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or      |
// | implied. See the License for the specific language governing         |
// | permissions and limitations under the License.                       |
// +----------------------------------------------------------------------+
// | Author: Bitflux GmbH <devel@bitflux.ch>                              |
// +----------------------------------------------------------------------+

*/
kukit.LiveSearch = function() {};

kukit.LiveSearch.prototype.liveSearchReq = false;
kukit.LiveSearch.prototype.t = null;
kukit.LiveSearch.prototype.liveSearchLast = "";

kukit.LiveSearch.prototype.searchInput = null; 
kukit.LiveSearch.prototype.resultNode = null; 
kukit.LiveSearch.prototype.highlightId = null; 

kukit.LiveSearch.prototype.isIE = false;

kukit.LiveSearch.prototype.widthOffset=1;

//kukit.LiveSearch.prototype.calculateWidth = function(){
//}

kukit.LiveSearch.prototype.getElementDimensions = function(base) {
    var offsetTrail = base;
    var offsetLeft = 0;
    var offsetTop = 0;
    var width = 0;
    
    while (offsetTrail) {
        offsetLeft += offsetTrail.offsetLeft;
        offsetTop += offsetTrail.offsetTop;
        offsetTrail = offsetTrail.offsetParent;
    }
    if (navigator.userAgent.indexOf("Mac") != -1 &&
        typeof document.body.leftMargin != "undefined") {
        offsetLeft += document.body.leftMargin;
        offsetTop += document.body.topMargin;
    }

    if(!this.isIE){
    width =  base.offsetWidth-this.widthOffset*2;
    }
    else {
    width = base.offsetWidth;
    }

    return { left:offsetLeft, 
         top:offsetTop, 
         width: width, 
             height: base.offsetHeight,
         bottom: offsetTop + base.offsetHeight, 
         right : offsetLeft + width};
};

kukit.LiveSearch.prototype.bind_searchbox = function(name, func_to_bind, oper) {
    oper.completeParms(['submit'], {'highlightId': 'LSHighlight'}, 'livesearch-searchbox event binding');
    oper.evalBool('submit', 'livesearch-searchbox event binding');
    var searchInput = oper.node;
    if (this.searchInput != null) {
        throw 'livesearch-searchbox event binder can only be bound to a single node; ';
    }
    if (searchInput == null) {
        throw 'livesearch-input event must be bound to a node.';
    }
    this._cache = new Object();
    this.searchInput = searchInput;
    this.highlightId = oper.parms.highlightId;

    // Make additional event funcs for binding
    var self = this;
    var func_keyPress = function(evt) {
        self.keyPress(evt);
    }
    var func_start = function(evt) {
        self.start(evt);
    }
    var func_hide = function(evt) {
        self.hide();
    }
    var func_hideDelayed = function(evt) {
        self.hideDelayed();
    }
    var func_submit = function(evt) {
        return self.submit();
    }

//  Only keypress catches repeats in moz/FF but keydown is needed for
//  khtml based browsers.
    if (navigator.userAgent.indexOf("KHTML") > 0) {
        searchInput.addEventListener("keydown",func_keyPress,false);
        searchInput.addEventListener("focus",func_to_bind,false);
        searchInput.addEventListener("keydown",func_start, false);
    } else if (searchInput.addEventListener) {
        searchInput.addEventListener("keypress",func_keyPress,false);
        searchInput.addEventListener("blur",func_hideDelayed,false);
        searchInput.addEventListener("keypress",func_start, false);
    } else {
        searchInput.attachEvent("onkeydown",func_keyPress);
        searchInput.attachEvent("onkeydown",func_start);
//      searchInput.attachEvent("onblur",func_hide);
        this.isIE = true;
    }

    // Also do the onSubmit
    if (oper.parms.submit) {
        var form = kukit.fo.getCurrentForm(searchInput);
        if (!form) {
            throw 'No form found in livesearch-searchinput event binder';
        }
        form.onsubmit = func_submit;
    }

//  Why doesn't this work in konq, setting it inline does.
    searchInput.setAttribute("autocomplete","off");

    this.liveSearchRoot = '';
    this.liveSearchRootSubDir = '';

    //this.finish_binding();
};

/*
kukit.LiveSearch.prototype.finish_binding = function() {
    // This is called when all nodes are bound.
    if (this.searchInput && this.resultNode) {
        var pos = this.getElementDimensions(this.searchInput); 
        pos.left = pos.left - this.resultNode.offsetParent.offsetLeft + pos.width;
        this.resultNode.style.display='none';
    }
};
*/

kukit.LiveSearch.prototype.hideDelayed = function() {
    var self = this;
    var func = function() {
        self.hide();
    }
    var timer = new kukit.ut.TimerCounter(400, func)
    timer.start();
};

kukit.LiveSearch.prototype.getFirstHighlight = function() {
    var set = this.getHits();
    return set[0];
};

kukit.LiveSearch.prototype.getLastHighlight = function() {
    var set = this.getHits();
    return set[set.length-1];
};

kukit.LiveSearch.prototype.getHits = function() {
    var set;
    if (this.resultNode != null) {
        set = this.resultNode.getElementsByTagName('li');
    } else {
        set = [];
    }
    return set
};

/*
kukit.LiveSearch.prototype.findChild = function(obj, specifier) {
    var cur = obj.firstChild;
    try {
        while (cur != undefined) {
            cur = cur.nextSibling;
            if (specifier(cur) == true) return cur;
        }
    } catch(e) {};
    return null;
    
};
*/

kukit.LiveSearch.prototype.findNext = function(obj, specifier) {
    var cur = obj;
    try {
        while (cur != undefined) {
            cur = cur.nextSibling;
            if (cur.nodeType==3) cur=cur.nextSibling;
        
            if (cur != undefined) {
                if (specifier(cur) == true) return cur;
            } else { break }
        }
    } catch(e) {};
    return null;
};

kukit.LiveSearch.prototype.findPrev = function(obj, specifier) {
    var cur = obj;
    try {
        cur = cur.previousSibling;
        if (cur.nodeType==3) cur=cur.previousSibling;
        if (cur!=undefined) {
            if (specifier(cur) == true) 
                return cur;
        } 
    } catch(e) {};
    return null;
};

kukit.LiveSearch.prototype.keyPress = function(event) {
    if (event.keyCode == 40 )
    //KEY DOWN
    {
        highlight = document.getElementById(this.highlightId);
        if (!highlight) {
            highlight = this.getFirstHighlight();
        } else {
            highlight.removeAttribute("id");
            highlight = this.findNext(highlight, function (o) {return o.className =="LSRow";});

        }
        if (highlight) {
            highlight.setAttribute("id", this.highlightId);
        } 
        if (!this.isIE) { event.preventDefault(); }
    } 
    //KEY UP
    else if (event.keyCode == 38 ) {
        highlight = document.getElementById(this.highlightId);
        if (!highlight) {
            highlight = this.getLastHighlight();
        } 
        else {
            highlight.removeAttribute("id");
            highlight = this.findPrev(highlight, function (o) {return o.className=='LSRow';});
        }
        if (highlight) {
                highlight.setAttribute("id", this.highlightId);
        }
        if (!this.isIE) { event.preventDefault(); }
    } 
    //ESC
    else if (event.keyCode == 27) {
        highlight = document.getElementById(this.highlightId);
        if (highlight) {
            highlight.removeAttribute("id");
        }
        this.hide()
    } 
};

kukit.LiveSearch.prototype.start = function(event) {
    if (this.t) {
        this.t.clear();
    }
    code = event.keyCode;
    if (code!=40 && code!=38 && code!=27 && code!=37 && code!=39) {
        var self = this;
        var func = function() {
            self.doSearch();
        }
        this.t = new kukit.ut.TimerCounter(200, func)
        this.t.start();
    } 
};

kukit.LiveSearch.prototype.doSearch = function() {

    if (this.searchInput.value == "") {
        this.hide();
        return false;
    }

    // Do nothing as long as we have less then two characters - 
    // the search results makes no sense, and it's harder on the server.
    if (this.searchInput.value.length < 2) {
        this.hide();
        return false;
    }

    // Do we have cached results
    var result = this._cache[this.searchInput.value];
    if (result) {
        this.showResult(result); 
        return;
    }
    // Send the request to the server, by triggering the event.
    this.__trigger_event__('searchbox', {'q': this.searchInput.value}, node);
};

kukit.LiveSearch.prototype.hide = function() { 
    if (this.resultNode) {
        var parentNode = this.resultNode.parentNode;
        parentNode.removeChild(this.resultNode);
        this.resultNode = null;
    }
};

kukit.LiveSearch.prototype.showResult = function(result) {
    this.hide();
    // always append after the search input
    var parentNode = this.searchInput.parentNode;
    result = kukit.dom.forceToDom(result);
    var element = result.firstChild;
    parentNode.appendChild(element);
    this.resultNode = parentNode.lastChild;
};

kukit.LiveSearch.prototype.exec_insert = function(name, oper) {
    oper.completeParms(['html'], {}, 'livesearch-insert event execution');
    var parms = oper.parms;
    parms.html = kukit.dom.forceToDom(parms.html);
    this.showResult(parms.html);
    this._cache[this.liveSearchLast] = parms.html;
};

kukit.LiveSearch.prototype.submit = function() {
    var highlight = document.getElementById(this.highlightId);
    
    if (highlight){
        target = highlight.getElementsByTagName('a')[0];
        window.location = this.liveSearchRoot + this.liveSearchRootSubDir + target;
        return false;
    } 
    else {
        return true;
    }
};

kukit.er.eventRegistry.register('livesearch', 'searchbox', kukit.LiveSearch, 'bind_searchbox', null);
kukit.er.eventRegistry.register('livesearch', 'insert', kukit.LiveSearch, null, 'exec_insert');

